subroutine policy_long2(maxm)
use nrtype
use parameters
use global_parameters
use global
use procedures,only:linspace,locate

implicit none

integer,intent(in) ::maxm
integer :: i,k,m,q,rj,aj
real(dp) :: r1,r2,a1,a2,ap,tot

do m=1,maxm+1
!amax(m)=max(maxval(ar(:,:,m)),maxval(ad(:,:,m)),maxval(ahz(:,:,m)),maxval(am(:,:,m)),maxval(ah(:,:,:,m)))
agrid2(:,m)=linspace(amin,amax(m),Na2)
end do
!agrid2=agrid
dgrid2=linspace(minval(dgrid),maxval(dgrid),Nd2)
!rmgrid2=linspace(rmk,maxval(rm,mask=rm.lt.rmmax),Nr2)
!agrid2=agrid
if (Nr2==Nr) then
rmgrid2=rmgrid
else
rmgrid2=linspace(minval(rmgrid),maxval(rmgrid),Nr2)
end if
!dgrid2=dgrid

do m=1,maxm
do i=1,Na2
do k=0,Nnu
ap=agrid2(i,m)
aj=locate(agrid(:,m),ap)
tot=agrid(aj+1,m)-agrid(aj,m)
a1=max((agrid(aj+1,m)-ap)/tot,0.0_dp)
a2=max((ap-agrid(aj,m))/tot,0.0_dp)

if (str(k,aj,m)==str(k,aj+1,m)) then
ar_long(k,i,m)=ar(k,aj,m)*a1+ar(k,aj+1,m)*a2
str_long(k,i,m)=str(k,aj,m)
rm_long(k,i,m)=rm(k,aj,m)*a1+rm(k,aj+1,m)*a2
phi_long(k,i,m)=phi(k,aj,m)*a1+phi(k,aj+1,m)*a2
else
str_long(k,i,m)=str(k,aj+nint(a2),m)
ar_long(k,i,m)=ar(k,aj+nint(a2),m)
rm_long(k,i,m)=rm(k,aj+nint(a2),m)
phi_long(k,i,m)=phi(k,aj+nint(a2),m)
end if

if (sthz(k,aj,m)==sthz(k,aj+1,m)) then
ahz_long(k,i,m)=ahz(k,aj,m)*a1+ahz(k,aj+1,m)*a2
sthz_long(k,i,m)=sthz(k,aj,m)
else
sthz_long(k,i,m)=sthz(k,aj+nint(a2),m)
ahz_long(k,i,m)=ahz(k,aj+nint(a2),m)
end if

if (stm(k,aj+Nd,m)==stm(k,aj+1+Nd,m)) then
am_long(k,i+Nd2,m)=am(k,aj+Nd,m)*a1+am(k,aj+1+Nd,m)*a2
stm_long(k,i+Nd2,m)=stm(k,aj+Nd,m)
else
stm_long(k,i+Nd2,m)=stm(k,aj+Nd+nint(a2),m)
am_long(k,i+Nd2,m)=am(k,aj+Nd+nint(a2),m)
end if
ad_long(k,i,m)=ad(k,aj,m)*a1+ad(k,aj+1,m)*a2
end do
end do
end do

do m=1,maxm
do i=1,Nd2
do k=0,Nnu
ap=dgrid2(i)
aj=locate(dgrid,ap)
tot=dgrid(aj+1)-dgrid(aj)
a1=max((dgrid(aj+1)-ap)/tot,0.0_dp)
a2=max((ap-dgrid(aj))/tot,0.0_dp)

if (stm(k,aj,m)==stm(k,aj+1,m)) then
am_long(k,i,m)=am(k,aj,m)*a1+am(k,aj+1,m)*a2
stm_long(k,i,m)=stm(k,aj,m)
else
stm_long(k,i,m)=stm(k,aj+nint(a2),m)
am_long(k,i,m)=am(k,aj+nint(a2),m)
end if

do q=1,Nr2
ap=rmgrid2(q)
rj=locate(rmgrid,ap)
tot=rmgrid(rj+1)-rmgrid(rj)
r1=max((rmgrid(rj+1)-ap)/tot,0.0_dp)
r2=max((ap-rmgrid(rj))/tot,0.0_dp)

if (sth(rj,k,aj,m)==sth(rj,k,aj+1,m).and.sth(rj,k,aj+1,m)==sth(rj+1,k,aj,m).and.&
sth(rj+1,k,aj,m)==sth(rj+1,k,aj+1,m)) then
ah_long(q,k,i,m)=ah(rj,k,aj,m)*r1*a1+ah(rj,k,aj+1,m)*r1*a2+&
                ah(rj+1,k,aj,m)*r2*a1+ah(rj+1,k,aj+1,m)*r2*a2
sth_long(q,k,i,m)=sth(rj,k,aj,m)
else                
sth_long(q,k,i,m)=sth(rj+nint(r2),k,aj+nint(a2),m)
ah_long(q,k,i,m)=ah(rj+nint(r2),k,aj+nint(a2),m)   
end if            
end do
end do
end do
end do

end subroutine